/* Constructor for VisualC++ 6.0 (HTML-logi). December 2000  */

/* #include <io.h> */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>
#include "two32.h"


struct D *SD[HTL];
struct R *SR[HTL];

FILE *Sem=NULL;

struct U{
	int x;
	int y;
	struct U *next;
};

struct U *UP=NULL;	


char s[8][60]={"",
	"<FONT COLOR=\"#0000FF\">=&#149</FONT>",
	"<FONT COLOR=\"#0000FF\">&lt&#149</FONT>",
	"<FONT COLOR=\"#FF0000\">&lt&#149=&#149</FONT>",	
	"<FONT COLOR=\"#0000FF\">&#149&gt</FONT>",	
	"<FONT COLOR=\"#0000FF\">=&#149&#149&gt</FONT>",		
	"<FONT COLOR=\"#FF0000\">&lt&#149&#149&gt</FONT>",		
	"<FONT COLOR=\"#FF0000\">&lt&#149=&#149&#149&gt</FONT>"
	}; 
	
/* char s[8][30]={"",
	"<IMG SRC=\"a.gif\">",
	"<IMG SRC=\"e.gif\">",
	"<IMG SRC=\"ea.gif\">",
	"<IMG SRC=\"j.gif\">",
	"<IMG SRC=\"ja.gif\">",
	"<IMG SRC=\"ej.gif\">",
	"<IMG SRC=\"eaj.gif\">"
	};	*/


void printD(struct D *t);
void make_rtf(void);

/* tekstimassiivi sisestamine kettalt */
char *r_text(char *pealkiri){
	FILE *tekst=NULL;
	char *B;
	char c;
	int  i;
	int  k;
	struct stat *buf;
	buf=(struct stat *)malloc(sizeof(struct stat));
	if(buf==NULL){
		sprintf(rida,"r_text: I haven't %d bytes of memory..",
			sizeof(struct stat));
		ExiT(rida);
		}		
 	tekst = fopen(pealkiri, "r");
	if (tekst==NULL){
		sprintf(rida,"cannot find the file  %s",pealkiri);
		ExiT(rida);
		}
	if(stat(pealkiri,buf)==-1){
		sprintf(rida,"r_text: stat failed");
		ExiT(rida);
		}
	k=buf->st_size;	
	B = (char *)malloc(k+10);
	if(B == NULL){
		sprintf(rida,"r_text: I have't %d bytes of memory..",k+10);
		ExiT(rida);
		}
	memset(B,'\0',k+10);
/* fill buffer */
	rewind(tekst);
	i=0;
	while (!feof(tekst)){
		c=fgetc(tekst);
		B[i]=c;
		i++;
	};
	P_length=i;
	for(i=P_length;i>0;i--){
		c=B[i]; if(isgraph(c)){
			i++;
			B[i]='\n';
			i++;
			B[i]='\0';
			P_length=i;
			goto out;
			}
		}	
out:	fclose(tekst);
	return(B);
}

int gramm(void){
	GBuf=r_text(fname);
	if(GBuf!=NULL){
		Glen=P_length;
		return(1);
		}
	return(0);
}

/* adresseerib maatrikseid sntaksi analsi ajal. nr=V pikkus */
int addr(int i, int j){
	int k;
	if(NR>0) goto indeks;
	if((i<1)||(j<1)||(i>nr)||(j>nr)){
		sprintf(rida,"addr: erroneus index nr=%d tnr=%d i=%d j=%d",
			nr,tnr,i,j);
		ExiT(rida);
		}
	indeks: 
	k=(i-1)*nr+j;
	if(NR>0) return(k);
	if(k>(nr+1)*(nr+1)){
		sprintf(rida,"addr: index %d le piiri. i=%d j=%d nr=%d",k,i,j,nr);
		ExiT(rida);
		} 
	return(k);
}

char *DefArray(int d){
	int n,i;
	char *M;
	n=(d*d);
	M=(char *)malloc(n);
	if(M==(char *)NULL){
		sprintf(rida,"DefArray: I don't have memory enough..");
		ExiT(rida);
		}
	for(i=0;i<n;i++) M[i]='\0'; 
	return(M);
}

/* vektoritele mlu eraldamine */
char *DefVect(int n){
	int i;
	char *M;
	M=(char *)malloc(n);
	if(M==(char *)NULL){
		sprintf(rida,"DefVect: I don't have memory enough..");
		ExiT(rida);
		}
	for(i=0;i<n;i++) M[i]='\0'; 
	return(M);
}

/* sltuva konteksti puu lemine tase: misted */
char ***defDEP(void){
	int i,n;
	n=(nr+1)*sizeof(char ***);
	DEP=(char ***)malloc(n);
	if(DEP==(char ***)NULL){
		sprintf(rida,"defDEP: I don't have memory enough..");
		ExiT(rida);
		}
	for(i=0;i<nr+1;i++) DEP[i]=(char **)NULL;
	return(DEP);
}

/* sltuva konteksti puu vahetase: vasakud kontekstid */
char **defL(void){
	int i,n;
	char **L;
	n=(nr+1)*sizeof(char **);
	L=(char **)malloc(n);
	if(L==(char **)NULL){
		sprintf(rida,"defL: I don't have memory enough..");
		ExiT(rida);
		}
	for(i=0;i<nr+1;i++) L[i]=(char *)NULL;
	return(L);
}

void ExiT(char *t){
	fprintf(Logi,"%s&lt;BR&gt;",t);
	fprintf(Logi,"&lt;"/BODY&gt;&lt;"/HTML&gt;");
	fflush(Logi);
	fclose(Logi);
	printf("%s",t);
	getchar();
	abort();
}

/* produktsioonide paisktabeli lli trkk */
void print_h(struct h *t){
	int i,j;
	char *r;
	fprintf(Logi,"P=%d `%s' -&gt ",t->P,T[t->NT]); 
	for(i=0;i<t->n;i++){
		j=t->d[i];
		r=T[j];
		if(j<=tnr) fprintf(Logi,"%s ",r);
		else fprintf(Logi,"`%s' ",r);
		}
	fprintf(Logi,"<BR>");
}

/* paiskfunktsioon (vti on prod. vahekeelne parem pool) */ 
int hfunc(int keylen,int *key){
	int h=0,g;
	int i;
	for(i=0;i<keylen;i++) h=h^key[i];
	g=h;
	h=h/HTL;
	h=g-(h*HTL);
	if((h<0)||(h>HTL)) ExiT("HT error!");
	return(h);
}

/* produktsiooni otsimine paisktabelist */
struct h *ReadHash(int n,int *key){
	struct h *t;
	int i,a;
	a=hfunc(n,key);
	t=HT[a];
otsi:	
	if(t!=(struct h *)NULL){
		if(n==t->n){
			for(i=0;i<n;i++){
				if(key[i]!=t->d[i]) goto next;
				}
			return(t);
			}		
		next: t=t->col;
		goto otsi;
		}	
	return(NULL);
}

/* produktsiooni paiskamine */
int HashRule(struct D *t,struct R *r){
	struct h *L,*TP,*S;
	int a,i;
	L=(struct h *)malloc(sizeof(struct h));
	if(L==NULL){
		sprintf(rida,"HashRule: I don't have memory enaugh..");
		ExiT(rida);
		}
	memset(L,'\0',sizeof(struct h));
	L->col=(struct h *)NULL;
	L->same=(struct h *)NULL;
	L->d=malloc(r->n*sizeof(int));
	if(L->d==NULL){
		sprintf(rida,"HashRule: I don't have memory enaugh..");
		ExiT(rida);
		}
	memcpy(L->d,r->d,r->n*sizeof(int));	
	L->n=r->n;
	L->NT=t->code;
	L->P=r->P;
	a=hfunc(L->n,L->d);
	if(HT[a] == (struct h *)NULL){
		HT[a]=L;
		return(1);
		}
	TP=HT[a];
	while(TP!=(struct h *)NULL){
		if(L->n==TP->n){
			for(i=0;i<L->n;i++){
				if(L->d[i]!=TP->d[i]) goto col;				
				}		
			S=TP->same;
			TP->same=L;
			L->same=S;
			BRC++;
			return(1);
			}
		col: TP=TP->col;
		}
	TP=HT[a];  
	HT[a]=L;
	L->col=TP;
	return(0);
}

/* Mitteterminali definitsioonide salvestamine */ 
void HashNT(struct D *t){
	struct R *r;
	r=t->def;
	while(r!=(struct R *)NULL){
		HashRule(t,r);
		r=r->alt;
		}
}

/* kikide mitteterminalide definitsioonide salvestamine */
void HashRules(struct D *t){
	if(t!=(struct D *)NULL){
		if(t->tunnus==0) HashNT(t);
		HashRules(t->left);
		HashRules(t->right);
		}
}

/* produktsioonide definitsitsioonide ahela lli trkk */
void print_L(struct h *CP){
int i,j;
char *r;
	fprintf(Logi,"P%2d `%s' -&gr ",CP->P,T[CP->NT]); 
	for(j=0;j<CP->n;j++){
		i=CP->d[j];
		r=T[i];
		if(i<tnr+1) fprintf(Logi,"%s ",r);
		else fprintf(Logi,"`%s' ",r);
		}
	fprintf(Logi,"<BR>");
}

/* produktsioonide paisktabeli trkk */
void print_HT(void){
	struct h *CP,*s;
	int i;
		fprintf(Logi,"<H4>Productions (HT):</H4>");
		for(i=0; i<HTL; i++){
			CP=HT[i];
			while(CP != (struct h *)NULL){
				print_L(CP);
				s=CP->same;
				while(s != (struct h *)NULL){
					print_L(s);
					s=s->same;
					}
				CP=CP->col;
				}
			}
}


/* leftmost ja rightmost: esimene lhendus */
void first_LR(struct D *t){
	struct R *r;
	int x;
	r=t->def;
ring:	if(r != (struct R *)NULL){
		if(t->tunnus==0){
			x=r->d[0];
			Lm[t->code][x]=1;
			x=r->d[r->n-1];
			Rm[t->code][x]=1;
			}
		r=r->alt;
		goto ring;
		}
}

/* leftmost: lisatakse L(A), kui A kuulub L */
void sec_LRL(int nt){
	int i,j;
	for(j=1; j<nr+1; j++){  
		if(Lm[j][nt]==1){
			for(i=1;i<nr+1;i++){
				if(Lm[nt][i]==1) Lm[j][i]=1;
				}
			}	
		}	
}

/* rightmost: lisatakse R(A), kui A kuulub R */
void sec_LRR(int nt){
	int i,j;
	for(j=1; j<nr+1; j++){  
		if(Rm[j][nt]==1){
			for(i=1;i<nr+1;i++){
				if(Rm[nt][i]==1) Rm[j][i]=1;
				}
			}	
		}	
}
				
/* mitteterminalide left- ja rightmost-hulkade moodustamine */
void make_LRB(void){
	int i;
	struct D *t;
	for(i=1; i<nr+1; i++){
		t=getV(T[i]);
/*		if(logi==1) fprintf(Logi,"LRM NT=%s<BR>",T[t->code]);		*/
		first_LR(t);
		}
	for(i=nr; i>tnr; i--){
		sec_LRL(i);
		sec_LRR(i);
		}
}

/* eelnevusmaatriksi koostamine: NT[i] relatsioonid maatriksisse */
int relac(struct D *t){
	struct R *r;
	int i,j,k,x,y;
	int ret=1;
	r=t->def;
ring:	if(r!=(struct R *)NULL){
			if(r->n==1) goto next;
			for(i=0;i<=r->n-2;i++){         /* def. paar x,y */
				x=r->d[i];
				y=r->d[i+1];
				if(Pm[x][y]!=0 && Pm[x][y]!=1) ret=0;
				Pm[x][y]=Pm[x][y]|1;      /* ajastub */
				if(y>tnr){         /* parem naaber on NT */
					for(k=1;k<nr+1;k++){
						if(Lm[y][k]==1){
							if(Pm[x][k]!=0 && Pm[x][k]!=2) ret=0;
							Pm[x][k]=Pm[x][k]|2;       /* iga eelneb */
							}
						}
					}
				if(x>tnr){          /* X on NT */
					for(k=1;k<nr+1;k++){
						if(Rm[x][k]==1){
							if(Pm[k][y]!=0 && Pm[k][y]!=4) ret=0;
							Pm[k][y]=Pm[k][y]|4;      /* iga j@rgneb*/
							}
						}
					}
				if((x>tnr)&&(y>tnr)){   /* X ja Y on NT */
					/* R(X) > L(Y) */
					for(j=1;j<nr+1;j++){
						if(Rm[x][j]==1){
							for(k=1;k<nr+1;k++){
								if(Lm[y][k]==1){
								if(Pm[j][k]!=0&&Pm[j][k]!=4) ret=0;
								Pm[j][k]=Pm[j][k]|4;
								}
							}
						}
					}
				}
			}
		next: r=r->alt;
		goto ring;
		}
	return(ret);
}

/* eelnevusmaatriksi koostamine: anna jrgmine NT */
int make_PM(void){
	int i;
	int ret=1;
	struct D *t;
	for(i=tnr+1; i<nr+1; i++){
		t=getV(T[i]);
/*		fprintf(Logi,"make_PM: i=%d NT=%s<BR>",i,T[i]);
		printD(t);  */
		ret=ret & relac(t);
		}
	return(ret);	
}

/* left- ja rightmost-hulkade trkk */
void print_LRM(char M[HTL][HTL]){
	int i,j;
	fprintf(Logi,"<TABLE BORDER=1>");
	fprintf(Logi,"<TR><TD><FONT COLOR=\"#0000FF\">Symbol</TD>");
	for(i=1;i<nr+1;i++){
		if(Nimi[0]=='G'||Nimi[0]=='g') 
			fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">%s</FONT></TD>",T[i]);
		else fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">%d</FONT></TD>",i);
		}
	fprintf(Logi,"</TR>");
	for(i=tnr+1; i<nr+1; i++){
		fprintf(Logi,
			"<TR><TD>%d.<FONT COLOR=\"#0000FF\">%s</FONT></TD>",
			i,T[i]);
		for(j=1; j<nr+1; j++){
			if(M[i][j]>0)
				fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">*</FONT></TD>");
			else fprintf(Logi,"<TD>0</TD>");			
				}
		fprintf(Logi,"</TR>");		
		}
	fprintf(Logi,"</TABLE>");
}

void cf(char *c){
	fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\"><STRONG>%s</FONT></TD>",c);
}

void p_r(char *R){
	cf(R);
	}
	
void p_cr(char *R){
	cf(R);
	}	

void print_rela(void){
int i,j,r;

	for(i=1;i<nr+1;i++){
		fprintf(Logi,
		"The relationships of symbol #<FONT COLOR=\"#0000FF\">%d ",i);
		if(i<=tnr) fprintf(Logi," %s</FONT>:<BR>",T[i]);
		else fprintf(Logi,"`%s'</FONT>:<BR>",T[i]);
		fprintf(Logi,"<TABLE BORDER=1><TR>");
		for(j=1;j<nr+1;j++){
			r=Pm[i][j];
			if(r>0){
				fprintf(Logi,"<TD>%s ",s[r]);
				if(j<=tnr) fprintf(Logi,"%s</TD>",T[j]);
				else fprintf(Logi,"`%s'</TD>",T[j]);
				}
			}
		fprintf(Logi,"</TR></TABLE><BR>");
		}
}

/* eelnevusmaatriksi trkk */
void print_PM(void){
	int i,j;
	fprintf(Logi,"<TABLE BORDER=1><STRONG>");
	fprintf(Logi,"<TR><TD><FONT COLOR=\"#0000FF\">Symbol</FONT></TD>");
	for(i=1;i<nr+1;i++){
		if(Nimi[0]=='G'||Nimi[0]=='g') 
			fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">%s</FONT></TD>",T[i]);
		else fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">%d</FONT></TD>",i);
		}
	fprintf(Logi,"</TR>");
	for(i=1; i<nr+1; i++){
		fprintf(Logi,
			"<TR><TD>%d.<FONT COLOR=\"#0000FF\">%s</FONT></TD>",
			i,T[i]);
		for(j=1; j<nr+1; j++){
			switch(Pm[i][j]){
				case 0: fprintf(Logi,"<TD>0</TD>"); break;
				case 1: cf("="); break;
				case 2: cf("&lt"); break;
				case 4: cf("&gt"); break;
				default: fprintf(Logi,
					"<TD><FONT COLOR=\"#FF0000\"><STRONG> %d</FONT></TD>",
					Pm[i][j]);
					break;
				}
			}
			fprintf(Logi,"</TR>");		
		}
	fprintf(Logi,"</TABLE>");
}

/* eelnevusmaatriksi trkk */
void print_rPM(void){
	int i,j;
	fprintf(rdf,"<TABLE BORDER=1><STRONG>");
	fprintf(rdf,"<TR><TD><FONT COLOR=\"#0000FF\">Nr</FONT></TD>");
	for(i=1;i<nr+1;i++)
		fprintf(rdf,"<TD><FONT COLOR=\"#0000FF\">%d</FONT></TD>",i);
	fprintf(rdf,"</TR>");
	for(i=1; i<nr+1; i++){
		fprintf(rdf,
			"<TR><TD><FONT COLOR=\"#0000FF\">%d</FONT></TD>",i);
		for(j=1; j<nr+1; j++) fprintf(rdf,"<TD>%d</TD>",Pm[i][j]);
		fprintf(rdf,"</TR>");		
		}
	fprintf(rdf,"</TABLE>");
}

/* stratifikatsioon paremale (P2-konflikt) */
void s_to_right(int lim, struct D *t,struct R *d){
	int k,r;
	int *sec;	
	struct D *n;
	struct R *b;
	fprintf(Logi,"The source is the production ");
	print_rule(t,d);
	memset(word,'\0',20);
	sprintf(word,"%s%d",T[t->code],Index);
	NR++;
	if(NR>HTL){
		sprintf(rida,"too many symbols");
		ExiT(rida);
		}
	memcpy(T[NR],word,20);
	Index++;
	DC=newD();
	b=newR();
	r=d->n-lim;
	b->d=(int *)malloc(r*sizeof(int));
	memset(b->d,'\0',r*sizeof(int));
	r=0;
	for(k=lim;k<d->n;k++){ 
		b->d[r]=d->d[k];
		r++;
		}
	b->n=r;
	DC->def=b;
	DC->code=NR;
	DC->tunnus=0;
	DC->L=t->L+1;
	b->P=Pnr;
	Pnr++;
	n=search(1);
	fprintf(Logi," I'll add a new NT ");
	print_rule(DC,b);

/* uus reegel on valmis. */					
	r=lim+1;
	sec=(int *)malloc(r*sizeof(int));
	memset(sec,'\0',r*sizeof(int));
	for(k=0;k<lim;k++) sec[k]=d->d[k];  
	sec[lim]=NR;
	d->n=lim+1;
/*	free(d->d);  */
	d->d=sec;
	fprintf(Logi,"  I'll change the production ");
	print_rule(t,d);
	fflush(Logi);
}	

/* P2_konflikti likvideerimine:
      A->xXYy asendada k6ikjal A->xXD, kus D->Yy  */
void P2(int x,int y){
	int i,j;
	struct D *t;
	struct R *d;
    /* otsin konflikti allikaid: definitsioone, kus on paar XY */ 	
	for(i=tnr+1; i<nr+1; i++){
		t=getV(T[i]);
		d=t->def;
ring: if(d!=(struct R *)NULL){	
		for(j=0;j<d->n-1;j++){
			if(d->d[j]==x){
				if(d->d[j+1]==y) s_to_right(j+1,t,d);
				}
			}
		d=d->alt;
		goto ring;
		}
	}
}

/* stratifikatsioon vasakule (P1-konflikt) */
void s_to_left(int lim, struct D *t,struct R *d){
	int k,r;
	int *sec;
	struct D *n;
	struct R *b;
	fprintf(Logi,"The source is the production ");
	print_rule(t,d);
	r=t->L;
	memset(word,'\0',20);
	sprintf(word,"%s%d",T[t->code],Index);
	NR++;
	if(NR>HTL){
		sprintf(rida,"too many symbols");
		ExiT(rida);
		}
	memcpy(T[NR],word,20);
	Index++;
	DC=newD();
	b=newR();
	b->d=(int *)malloc(lim*sizeof(int));
	memset(b->d,'\0',lim*sizeof(int));
	for(k=0;k<lim;k++) b->d[k]=d->d[k];
	b->n=lim;
	DC->def=b;
	DC->code=NR;
	DC->tunnus=0;
	DC->L=r+1;
	b->P=Pnr;
	Pnr++;
	n=search(1);
	fprintf(Logi," I'll add a new NT ");
	print_rule(DC,b);
/* uus reegel on valmis. */					
	r=d->n-lim;
	sec=(int *)malloc(r*sizeof(int));
	memset(sec,'\0',r*sizeof(int));
	sec[0]=n->code;
	r=1;
	for(k=lim;k<d->n;k++){
		sec[r]=d->d[k];
		r++;
		} 
	d->n=r;
/*	free(d->d); */
	d->d=sec;
	fprintf(Logi,"  I'll change the production ");
	print_rule(t,d);
	fflush(Logi);	
}	

/* P1-konflikti likvideerimine:
   A->xXYy asendada k6ikjal A->DYy, kus D->xX  */
void P1(int x,int y){
	int i,j,u;
	struct D *t;
	struct R *d;
/* otsin konflikti allikaid: definitsioone, kus on paar XY 
   vi XZ ja Y kuulub LM[Z]*/
for(i=tnr+1; i<nr+1; i++){
	t=getV(T[i]);
	d=t->def;
ring: if(d!=(struct R *)NULL){	
		for(j=0;j<d->n-1;j++){
			if(d->d[j]==x){
				if(d->d[j+1]==y){
					s_to_left(j+1,t,d);
					}
				else{
					if(d->d[j+1]>tnr){
						u=d->d[j+1];
						if(Lm[u][y]==1)	s_to_left(j+1,t,d);
						}
					}			
				}
			}	
		d=d->alt;
		goto ring;
		}
	}
}

/* teade eelnevuskonfliktist */
void tell_conf(int p,int i,int j,int c){
	fprintf(Logi,"<FONT COLOR=\"#FF0000\">");
	fprintf(Logi,"<BR>P%d-conflict: </FONT>",p);
	if(i<=tnr) fprintf(Logi,"%s <FONT COLOR=\"#FF0000\">%s </FONT>",T[i],s[c]);
	else fprintf(Logi,"`%s' <FONT COLOR=\"#FF0000\">%s </FONT>",T[i],s[c]);
	if(j<=tnr) fprintf(Logi,"%s<BR>",T[j]);
	else fprintf(Logi,"`%s'<BR>",T[j]);	
	fprintf(Logi,"</FONT>");
}	

/* eelnevuskonfliktide detekteerimine ja likvideerimine */
int conflicts(void){
	int i,j;
	int res=0;
	int oldN;
	NR=nr;
	for(i=1;i<nr+1;i++){
		for(j=1;j<nr+1;j++){
			if(Pm[i][j]==3){
				res=1;
				tell_conf(2,i,j,3);
				oldN=NR;
				P2(i,j);
				if(NR==oldN){
					fprintf(Logi,"Cannot find any source");
/*					ExiT();  */
					}
				}
			}
		}
	if(res==0) goto p1;
	memset(Lm,'\0',HTL*HTL);
	memset(Rm,'\0',HTL*HTL);
	nr=NR;
	make_LRB();
	fprintf(Logi,"<H4>Leftmost-set</H4>");
	print_LRM(Lm);  
p1:	for(i=1;i<nr+1;i++){
		for(j=1;j<nr+1;j++){
			if(Pm[i][j]>4){
				res=1;
				tell_conf(1,i,j,Pm[i][j]);
				oldN=NR;
				P1(i,j);
				if(NR==oldN){
					fprintf(Logi,"Cannot find any source");
					goto out;
					}
				}
			}
		}
out:
	nr=NR;
	return(res);
}

/* vasaku konteksti maatriksi trkk */
void print_LC(void){
	int i,j;
	fprintf(Logi,"<TABLE BORDER=1>");
	fprintf(Logi,"<TR><TD><FONT COLOR=\"#0000FF\">Symbol</TD>");
	for(i=1;i<nr+1;i++){
		if(Nimi[0]=='G'||Nimi[0]=='g') 
			fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">%s</TD>",T[i]);
		else fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">%d</TD>",i);
		}
	fprintf(Logi,"</TR></FONT>");
	for(i=tnr+1; i<nr+1; i++){
		fprintf(Logi,
			"<TR><TD>%d.<FONT COLOR=\"#0000FF\">%s</FONT></TD>",
			i,T[i]);
		for(j=1; j<nr+1; j++){
			if(LC[addr(i,j)]>0)
				fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">*</FONT></TD>");
			else fprintf(Logi,"<TD>0</TD>");			
				}
		fprintf(Logi,"</TR>");		
		}
	fprintf(Logi,"</TABLE>");
}

/* parema konteksti maatriksi trkk */
void print_RC(void){
	int i,j;
	fprintf(Logi,"<TABLE BORDER=1>");
	fprintf(Logi,"<TR><TD><FONT COLOR=\"#0000FF\">Symbol</TD>");
	for(i=1;i<tnr+1;i++){
		if(Nimi[0]=='G'||Nimi[0]=='g') 
			fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">%s</TD>",T[i]);
		else fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">%d</TD>",i);
		}
	fprintf(Logi,"</TR></FONT>");
	for(i=tnr+1; i<nr+1; i++){
		fprintf(Logi,
			"<TR><TD>%d.<FONT COLOR=\"#0000FF\">%s</FONT></TD>",
			i,T[i]);
		for(j=1; j<tnr+1; j++){
			if(RC[addr(i,j)]>0)
				fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">*</FONT></TD>");
			else fprintf(Logi,"<TD>0</TD>");			
				}
		fprintf(Logi,"</TR>");		
		}
	fprintf(Logi,"</TABLE><BR><BR>");
}


/* vasaku konteksti maatriksi trkk */
void print_rLC(void){
	int i,j;
	fprintf(rdf,"<TABLE BORDER=1>");
	fprintf(rdf,"<TR><TD><FONT COLOR=\"#0000FF\">Nr</TD>");
	for(i=1;i<nr+1;i++){
		fprintf(rdf,"<TD><FONT COLOR=\"#0000FF\">%d</TD>",i);
		}
	fprintf(rdf,"</TR></FONT>");
	for(i=tnr+1; i<nr+1; i++){
		fprintf(rdf,"<TR><TD><FONT COLOR=\"#0000FF\">%d</FONT></TD>",i);
		for(j=1; j<nr+1; j++){
			fprintf(rdf,"<TD>%d</TD>",LC[addr(i,j)]);
			}
		fprintf(rdf,"</TR>");		
		}
	fprintf(rdf,"</TABLE>");
}

/* parema konteksti maatriksi trkk */
void print_rRC(void){
	int i,j;
	fprintf(rdf,"<TABLE BORDER=1>");
	fprintf(rdf,"<TR><TD><FONT COLOR=\"#0000FF\">Nr</TD>");
	for(i=1;i<tnr+1;i++){
		fprintf(rdf,"<TD><FONT COLOR=\"#0000FF\">%d</TD>",i);
		}
	fprintf(rdf,"</TR></FONT>");
	for(i=tnr+1; i<nr+1; i++){
		fprintf(rdf,
			"<TR><TD><FONT COLOR=\"#0000FF\">%d</FONT></TD>",i);
		for(j=1; j<tnr+1; j++){
			fprintf(rdf,"<TD>%d</TD>",RC[addr(i,j)]);
			}
		fprintf(rdf,"</TR>");		
		}
	fprintf(rdf,"</TABLE><BR><BR>");
}

/* mitteterminali sltumatu konteksti hulga moodustamine */
void brc(int NT){
	int A,i;
	A=NT;
	for(i=1;i<nr+1;i++){
		if((Pm[i][A]==1)||(Pm[i][A]==2)) LC[addr(A,i)]=1;
		}
	for(i=1;i<tnr+1;i++){
		if(Pm[A][i]>0) RC[addr(A,i)]=1;
		}
}

/* mitteterminali sltumatu konteksti hulga trkk */
void p_brc(int NT){
	int A,i,f;
	A=NT;
	f=0;
	fprintf(Logi,"<FONT COLOR=\"#0000FF\">`%s' left context: </FONT>",T[NT]);
	for(i=1;i<nr+1;i++){
		if(LC[addr(A,i)]==1){
			if(f==0) f++;
			else fprintf(Logi,"<FONT COLOR=\"#FF4500\"><STRONG> , </FONT>");
			if(i<=tnr) fprintf(Logi," %s ",T[i]);
			else fprintf(Logi," `%s' ",T[i]);
			}
		}
	fprintf(Logi,"<BR></FONT>");	
	f=0;
	fprintf(Logi,"<FONT COLOR=\"#0000FF\">`%s' right context: </FONT>",T[NT]);
	for(i=1;i<tnr+1;i++){
		if(RC[addr(A,i)]==1){
			if(f==0) f++;
			else fprintf(Logi,"<FONT COLOR=\"#FF4500\"><STRONG> , </FONT>");
			fprintf(Logi,"%s ",T[i]);
			}			
		}
	fprintf(Logi,"<BR><BR>");	
	fflush(Logi);
}

void p_all_brc(void){
	int i;
	fprintf(Logi,
		"<H4><FONT COLOR=\"#0000FF\">Independent context</H4></FONT>");
	for(i=tnr+1;i<=nr;i++) p_brc(i);
}	

void p_lr(int NT){
	int A,i,f;
	A=NT;
	f=0;
	fprintf(Logi,"<FONT COLOR=\"#0000FF\">`%s' leftmost set: </FONT>",T[NT]);
	for(i=1;i<nr+1;i++){
		if(Lm[A][i]==1){
			if(f==0) f++;
			else fprintf(Logi,"<FONT COLOR=\"#FF4500\"><STRONG> , </FONT>");
			fprintf(Logi," `%s' ",T[i]);
			}
		}
	fprintf(Logi,"<BR></FONT>");	
	f=0;
	fprintf(Logi,"<FONT COLOR=\"#0000FF\">`%s' rightmost set: </FONT>",T[NT]);
	for(i=1;i<nr+1;i++){
		if(Rm[A][i]==1){
			if(f==0) f++;
			else fprintf(Logi,"<FONT COLOR=\"#FF4500\"><STRONG> , </FONT>");
			fprintf(Logi,"%s ",T[i]);
			}			
		}
	fprintf(Logi,"<BR><BR>");	
	fflush(Logi);
}

void p_all_lr(void){
	int i;
	fprintf(Logi,
		"<H4><FONT COLOR=\"#0000FF\">Leftmost & rightmost sets</H4></FONT>");
	for(i=tnr+1;i<=nr;i++) p_lr(i);
}	

void make_all_indep(void){
int i;
for(i=tnr+1;i<nr+1;i++) brc(i);
fprintf(Logi,"<FONT COLOR=\"#0000FF\"><H4>Left Context</H4></FONT><BR>");
print_LC();
fprintf(Logi,"<BR><FONT COLOR=\"#0000FF\"><H4>Right Context</H4></FONT><BR>");
print_RC();
}	

int deptest(struct h *x,struct h *y){
	BRC++;
	fprintf(Logi,"independent context didn't help us. ");
     fprintf(Logi,"I'll try to use the dependent one.<BR>");
	fflush(Logi);
     if(DEP==NULL) DEP=defDEP();
     dc=1;
	memset(word,'\0',20);
	si=0;
	DepV[x->P]=1;
	DepV[y->P]=1;
	dc=search_springs(x,x->NT);
	if(dc==0) return(0);
	memset(word,'\0',20);
	si=0;
	dc=search_springs(y,y->NT);
	fflush(Logi);
	if(dc==1){
		dc=test_dep_con(x,y);
		if(dc==1) dep++;
		}
	fflush(Logi);	
	return(dc);
}

int testpaar(int A,int B){
	int i,s;
	s=0;
	for(i=1;i<nr+1;i++){
		if(LC[addr(A,i)]==1){
			if(LC[addr(B,i)]==1) goto rc;
			}
		}
	fprintf(Logi,"<FONT COLOR=\"#008000\">The left context of </FONT>");
	fprintf(Logi,"`%s' ",T[A]);
	fprintf(Logi,"<FONT COLOR=\"#008000\">and </FONT> `%s'",T[B]);
	fprintf(Logi,"<FONT COLOR=\"#008000\"> is different<BR></FONT>");
	return(0);
rc:	for(i=1;i<tnr+1;i++){
		if(RC[addr(A,i)]==1){
			if(RC[addr(B,i)]==1){
				fprintf(Logi,"<FONT COLOR=\"#FF0000\">");
				fprintf(Logi,
				"The independent context of </FONT>`%s' <FONT COLOR=\"#FF0000\">and </FONT>`%s' <FONT COLOR=\"#FF00000\">is not different<BR>",
				T[A],T[B]);
				fprintf(Logi,"</FONT><HR>");
				return(1);
				}
			}
		}	
	fprintf(Logi,"<FONT COLOR=\"#008000\">The right context of </FONT>");
	fprintf(Logi,"`%s' ",T[A]);
	fprintf(Logi,"<FONT COLOR=\"#008000\">and </FONT> `%s'",T[B]);
	fprintf(Logi,"<FONT COLOR=\"#008000\"> is different<BR></FONT>");
	return(0);
}

/*  mitteterminalide konteksti eristumise test */
int brctest(struct h *t){
	struct h *x,*y;
	struct h *SAM[40];
	int ns;
	int j,k,A,B;
	for(j=0;j<40;j++) SAM[j]=(struct h *)NULL;
	x=t;
	ns=0;
fill: SAM[ns]=x;
	ns++;
	x=x->same;
	if(x!=(struct h *)NULL) goto fill;
	fflush(Logi);
	for(j=0;j<ns-1;j++){
		x=SAM[j];
		A=x->NT;
		for(k=j+1;k<ns;k++){
			y=SAM[k];
			B=y->NT;
			if(testpaar(A,B)!=0) deptest(x,y);
			fflush(Logi);
			}
		}	
	return(1);
}

/* otsib hesuguse parema poolega produktsioone, teeb C1|1-hulgad */
int make_BRC(void){
	struct h *CP,*S;
	int i,j,k;
	char *r;
	BRC=0;
fprintf(Logi,"<HR>");
	for(i=0; i<HTL; i++){
		CP=HT[i];
		while(CP != (struct h *)NULL){
			if(CP->same!=(struct h *)NULL){
				fprintf(Logi,"<FONT COLOR=\"#FF0000\">");
				fprintf(Logi,"Equivalent definitions:</FONT><BR>");
				S=CP;
				p: fprintf(Logi,"`%s' &#151&gt ",T[S->NT]);
				fflush(Logi);
				for(j=0;j<S->n;j++){
					k=S->d[j];
					r=T[k];
					if(k<=tnr) fprintf(Logi,"%s ",r);
					else fprintf(Logi,"`%s' ",r);
					fflush(Logi);
					}
				S=S->same;
				if(S==(struct h *)NULL) goto B;
				fprintf(Logi,"<FONT COLOR=\"#FF0000\"> &amp </FONT>");
				goto p;
				B: fprintf(Logi,"<BR>");
				fflush(Logi);
				p_brc(CP->NT);
				}
			S=CP->same;
			while(S != (struct h *)NULL){
				p_brc(S->NT);
				S=S->same;
				fflush(Logi);
				}
			if(CP->same!=(struct h *)NULL){
				fprintf(Logi,"<BR>");
				if(brctest(CP)==0) return(0);
				fprintf(Logi,"<BR>");
				fflush(Logi);
				}
			CP=CP->col;
			}
	}
	return(1);
}

/* eemaldab pseudo-s6ltuvad kontekstid */
void del_dep(void){
	struct h *CP,*S;
	int i,k;
	for(i=0; i<HTL; i++){
		CP=HT[i];
		while(CP != (struct h *)NULL){
			if(CP->same!=(struct h *)NULL){
				k=CP->P;
				if(DepV[k]==0) CP->nc=0;
				}
			S=CP->same;
			while(S != (struct h *)NULL){
				k=S->P;
				if(DepV[k]==0) S->nc=0;
				S=S->same;
				}
			CP=CP->col;
			}
	}
}

void pset(int x,int y){
	fprintf(Logi," {");
	fprintf(Logi,"<FONT COLOR=\"#0000FF\">");
	if(x<=tnr) fprintf(Logi,"%s ",T[x]);
	else fprintf(Logi,"`%s' ",T[x]);
	fprintf(Logi,"<FONT COLOR=\"#FF4500\"><STRONG> , </FONT>");
	if(y<=tnr) fprintf(Logi,"%s",T[y]);
	else fprintf(Logi,"`%s'",T[y]);
	fprintf(Logi,"</FONT>");
	fprintf(Logi,"} ");	
}

void priv(char *v){
	int i;
	for(i=0;i<tnr+1;i++) fprintf(Logi,"%d ",v[i]);
	fprintf(Logi,"<BR>");
}	

void print_DEP(void){
char **L;
char *rc;
int i,j,k;
	for(i=0;i<nr+1;i++){
		L=DEP[i];
		if(L!=(char **)NULL){
			fprintf(rdf,"<BR>DEP[%d]=%p<BR>",i,L);
			for(j=0;j<nr+1;j++){
				rc=L[j];
				if(rc!=(char *)NULL){
					fprintf(rdf,"L[%d]=%p<BR>",j,rc);
					for(k=0;k<tnr+1;k++)
					   if(rc[k]>0) fprintf(rdf,"rc[%d]=%d ",k,rc[k]);
					fprintf(rdf,"<BR>");
					}
				}
			}
		}
}

void join_cxt(char **D,char **S){
	int i,j;
	char *rc,*src;
	for(i=1;i<nr+1;i++){
		if(S[i]!=(char *)NULL){
			src=S[i];
			rc=D[i];
			if(rc==(char *)NULL){
				rc=DefVect(tnr+1);
				D[i]=rc;
				}
			for(j=1;j<tnr+1;j++){
				if(src[j]==1) rc[j]=src[j];
				}
			}
		}
}

int test_cxt(char **D,char **S){
	int i,j,x;
	int flag=1;
	char *rc,*src;
	for(i=1;i<nr+1;i++){
		src=S[i];
		if(src!=(char *)NULL){
			rc=D[i];
			if(rc!=(char *)NULL){
				for(j=1;j<tnr+1;j++){
					x=rc[j];
					if(x==1){
						if(src[j]==1){
							flag=0;
							fprintf(Logi,
								"<FONT COLOR=\"red\"><BR>common:</FONT>");
							pset(i,j);
							fprintf(Logi,"<BR>");
							}
						}
					}
				}
			}
		}
	return(flag);
}

void print_cxt(char **L){
	int i,j;
	char *rc;
	for(i=1;i<nr+1;i++){
		rc=L[i];
		if(rc!=(char *)NULL){
			for(j=1;j<tnr+1;j++){
				if(rc[j]==1) pset(i,j);
				}
			}
		}
	fflush(Logi);
}

void print_cxtp(char **L){
int i;
	char *rc;
	for(i=1;i<nr+1;i++){
		rc=L[i];
		if(rc!=(char *)NULL) fprintf(Logi,"L[%d]=%p<BR>",i,rc);
		}
}

void print_all_cxt(void){
char **L;
int i;
	fprintf(Logi,
		"<H4><FONT COLOR=\"#0000FF\">Dependent context</H4></FONT>");
	for(i=tnr+1;i<nr+1;i++){
		L=DEP[i];
		if(L!=(char **)NULL){
			fprintf(Logi,"<BR>dependent context of `%s':<BR>",T[i]);
			print_cxt(L);
			fprintf(Logi,"<BR>");
			}
		}
/*	print_DEP();	*/
}

void print_all_cxtp(void){
char **L;
int i;
	for(i=tnr+1;i<nr+1;i++){
		L=DEP[i];
		if(L!=(char **)NULL){
			fprintf(Logi,"DEP[%d]=%p<BR>",i,L);
			print_cxtp(L);
			}
		}
}

/* sltuv kontekst. g1(A)={(X,T) | B->uXADv & [T=D or T in L(D)]}  */
int g1(char **L,int X,int D){
	int i;
	char *rc;
	rc=L[X];
	if(rc==(char *)NULL){
		rc=DefVect(tnr+1);
		L[X]=rc;
		}
	if(D>tnr){
		for(i=1;i<tnr+1;i++){
			if(Lm[D][i]==1){
				rc[i]=1;
				pset(X,i);
				}
			}
		}
	else{
		rc[D]=1;
		pset(X,D);
		}
	fprintf(Logi,"<BR>");
	return(1);
}

/* sltuv kontekst. g2(A)={(X,T) | B->uXA & T in RC(B)]}  */
int g2(char **L,struct h *t,int X){
	int i;
	char *rc;
	rc=L[X];
	if(rc==(char *)NULL){
		rc=DefVect(tnr+1);
		L[X]=rc;
		}
	for(i=1;i<tnr+1;i++){
		if(RC[addr(t->NT,i)]==1){
			rc[i]=1;
			pset(X,i);
			}
		}
	fprintf(Logi,"<BR>");
	return(1);
}

/* sltuv kontekst. g3(A)={(X,T) | B->ADv & X in LC(B) & [T=D or T in L(D)]} */
int g3(char **L,struct h *t,int D){
int i,j;
char *rc;
for(i=1;i<=nr;i++){
	if(LC[addr(t->NT,i)]==1){
		if(D<=tnr){
			rc=L[i];
			if(rc==(char *)NULL){
				rc=DefVect(tnr+1);
				L[i]=rc;
				}
			rc[D]=1;
			pset(i,D);
			}
		else{
			for(j=1;j<tnr+1;j++){
				if(Lm[D][j]==1){
					rc=L[i];
					if(rc==(char *)NULL){
						rc=DefVect(tnr+1);
						L[i]=rc;
						}
					rc[j]=1;
					pset(i,j);
					}
				}
			}
		}
	}
	fprintf(Logi,"<BR>");
	return(1);
}

/* sltuv kontekst. g4(A)={(X,T) | B->A & (X,T) in C1,1(B)}  */
int g4(char **L,struct h *t){
	char **S;
	if(t->nc==0) search_springs(t,t->NT);
	if(dc==0) return(0);
	S=DEP[t->NT];
	join_cxt(L,S);
	fflush(Logi);
	return(1);
}

/* otsib mitteterminali A sltuva konteksti allikaid, moodustab C1,1(A) */
int search_springs(struct h *t,int A){
char **L;
struct h *C;
int i,j,k;
int Word[40];
L=DEP[A];
if(L==(char **)NULL){
	L=defL();
	DEP[A]=L;
	}
fprintf(Logi,"<BR><BR>I'll find the subsets of dependent context of `%s'<BR>",
	T[t->NT]);
fflush(Logi);
for(i=0;i<si+1;i++){
	if(Word[i]==A){
		fprintf(Logi,"<BR>deadlock, the next will be `%s'<BR>",T[A]);
		for(j=0;j<i+1;j++){
			k=Word[j];
			fprintf(Logi,"  %s ",T[k]);
			}
		fprintf(Logi,"<BR>");
		fflush(Logi);
		dc=0;
		goto out;
		}
	}	
Word[si]=A;
si++;
for(i=0;i<Pnr;i++){
C=prod[i];
if(C!=(struct h *)NULL){	
	for(j=0;j<C->n;j++){
		if(C->d[j]==A){
			if((j==0)&&(C->n==1)){
				fprintf(Logi,"<FONT COLOR=\"#008000\">");
				fprintf(Logi,
				"gamma4:</FONT> the source is the production <BR>");
				print_h(C);
				if(g4(L,C)==0) goto out;
				fflush(Logi);
				goto nextj;
				}			
			if(j==0){
				fprintf(Logi,"<FONT COLOR=\"#008000\">");
				fprintf(Logi,
				"gamma3: </FONT> the source is the production <BR>");
				print_h(C);
				g3(L,C,C->d[1]);
				goto nextj;
				}
			if((j>0)&&(j!=C->n-1)){
				fprintf(Logi,"<FONT COLOR=\"#008000\">");
				fprintf(Logi,
				"gamma1: </FONT> the source is the production <BR>");
				print_h(C);
			     g1(L,C->d[j-1],C->d[j+1]);
				goto nextj;
				}
			if(j==C->n-1){
				fprintf(Logi,"<FONT COLOR=\"#008000\">");
				fprintf(Logi,
				"gamma2:</FONT> the source is the production <BR>");
				print_h(C);
				g2(L,C,C->d[C->n-2]);
				goto nextj;
				}
			}	
		nextj: fflush(Logi);
		}		
	}
}
Word[si]=0;
si--;
t->nc=1;
fprintf(Logi,"<BR>The set of dependent context of `%s':<BR>",T[A]);
print_cxt(L);
fprintf(Logi,"<BR>");
fflush(Logi);
out:	return(dc);
}

void p_nlist(){
struct U *u;	
u=UP;
fprintf(Logi,"<FONT COLOR=\"#FF0000\">");
fprintf(Logi,
 "<BR>The following pairs of nonterminals are having nondifferent context:<BR>");
fprintf(Logi,"</FONT>");
while(u!=(struct U *)NULL){
	fprintf(Logi,"`%s'",T[u->x]);
	fprintf(Logi,"<FONT COLOR=\"#FF0000\">and </FONT>");
	fprintf(Logi,"`%s'<BR>",T[u->y]);
	u=u->next;
	}
fprintf(Logi,"<BR>");
fflush(Logi);
}		

void add_not(int x,int y){
	struct U *u;
	u=(struct U *)malloc(sizeof(struct U));
	u->x=x;
	u->y=y;
	u->next=UP;
	UP=u;
}	

/* C1,1(A) ja C1,1(B) eristumise test */
int test_dep_con(struct h *x,struct h *y){
	int flag;
	char **A,**B;

	A=DEP[x->NT];
	B=DEP[y->NT];
	fprintf(Logi,"<BR>test_dep_con ");	
	fprintf(Logi,"<FONT COLOR=\"#0000FF\"> %s </FONT> and ",T[x->NT]);
	fprintf(Logi,"<FONT COLOR=\"#0000FF\"> %s </FONT><BR>",T[y->NT]);
	flag=test_cxt(A,B);
	if(flag==0){
		fprintf(Logi,"<FONT COLOR=\"#FF0000\">");
		fprintf(Logi,
			"<BR>dependent context is not different: </FONT>%s ",T[x->NT]);
		fprintf(Logi,"<FONT COLOR=\"#FF0000\">and </FONT>");
		fprintf(Logi," %s<BR>",T[y->NT]);
		add_not(x->NT,y->NT);
		fprintf(Logi,"<HR>");
		return(0);
		}
	BRC--;
	fprintf(Logi,"<FONT COLOR=\"#008000\">");
	fprintf(Logi,"<BR>dependent context of `%s' and `%s' is different<BR></FONT>",
			T[x->NT],T[y->NT]);
	fprintf(Logi,"<HR>");		
	fflush(Logi);
	return(1);
}

void print_h_lyli(struct h *s){
int i;
	fprintf(rdf," h %p: P=%d n=%d NT=%d d=%p nc=%d same=%p col=%p",
       s,s->P,s->n,s->NT,s->d,s->nc,s->same,s->col);
	fprintf(rdf,"<FONT COLOR=\"#0000FF\">  (%s)</FONT><BR>",T[s->NT]);       
	fprintf(rdf," d %p: ",s->d);
	for(i=0;i<s->n;i++) fprintf(rdf,"%d ",s->d[i]);
	fprintf(rdf,"<BR>");
	fflush(rdf);
	if(s->same!=(struct h *)NULL) print_h_lyli(s->same);	
	if(s->col!=(struct h *)NULL) print_h_lyli(s->col);
}

void print_h_tabel(void){
struct h *t;
int i;
	for(i=0;i<HTL;i++){
		t=HT[i];
		if(t!=(struct h *)NULL) print_h_lyli(t);
		}
}

/* thestiku V puu tipu trkk */
void printD(struct D *t){
struct R *r;
int i;
fprintf(rdf," D %p: tunnus=%d code=%d L=%d loc=%d icx=%d left=%p right=%p def=%p   ", 
t,t->tunnus,t->code,t->L,t->loc,t->icx,t->left,t->right,t->def);
fprintf(rdf,"<FONT COLOR=\"#0000FF\">(%s)</FONT><BR>",T[t->code]);
r=t->def;
ring:	if(r != (struct R *)NULL){
		fprintf(rdf," R %p: P=%d sem=%d n=%d d=%p alt=%p<BR>",
		r,r->P,r->sem,r->n,r->d,r->alt);
		fprintf(rdf," d %p: ",r->d);
		for(i=0;i<r->n;i++){
			fprintf(rdf,"%d ",r->d[i]);
			}
		fprintf(rdf,"<BR>");
		r=r->alt;
		goto ring;
		}
}

/* thestiku V vljatrkk */
void print_tree(struct D *t){
	if(t->left != (struct D *)NULL) print_tree(t->left);
	printD(t);
	if(t->right != (struct D *)NULL) print_tree(t->right);
}

FILE *opw(void){
	FILE *of=NULL;
	of=fopen(rida,"wb");
	if (of==NULL){
		fclose(of);
		fprintf(Logi,"<BR>cannot create the file %s<BR>",rida);
		}
	return(of);
}

void w_V(FILE *of,struct D *t){
	struct R *d;
	struct R *prev;
	int q;
	if(t!=(struct D *)NULL){
		q=fwrite(t,sizeof(struct D),1,of);
		if(q!=1){
			sprintf(rida,"write error w_V()<BR>");  
			ExiT(rida);
			}
		if(t->tunnus==0){
			d=t->def;
			while(d!=(struct R *)NULL){
				q=fwrite(d,sizeof(struct R),1,of);
				if(q!=1){
					sprintf(rida,"write error w_V()<BR>");  
					ExiT(rida);
					}
				q=fwrite(d->d,d->n*sizeof(int),1,of);
				if(q!=1){
					sprintf(rida,"write error w_V()<BR>");  
					ExiT(rida);
					}
				prev=d; 
				d=d->alt;
				}
			}	
		w_V(of,t->left);
		w_V(of,t->right);
		}
}		

void w_DEP(FILE *of){
	int i,j,q;
	char **L;
	char *rc;
	q=fwrite(DEP,sizeof(char ***),nr+1,of);
	if(q!=nr+1){
		sprintf(rida,"write error w_DEP()<BR>");  
		ExiT(rida);
		}
	for(i=0;i<(nr+1);i++){
		if(DEP[i]!=(char **)NULL){
			L=DEP[i];
			q=fwrite(L,sizeof(char **),nr+1,of);
			if(q!=nr+1){
				sprintf(rida,"write error w_DEP()<BR>");
				ExiT(rida);
				}
			for(j=0;j<nr+1;j++){
				rc=L[j];
				if(rc!=(char *)NULL){
					q=fwrite(rc,tnr+1,1,of);
					if(q!=1){
						sprintf(rida,"write error w_DEP()<BR>");
						ExiT(rida);
						}
					}
				}
			}
		}
/*	print_all_cxt();	*/
}					
				

void w_hr(FILE *of,struct h *r){
	int q;
	q=fwrite(r,sizeof(struct h),1,of);
	if(q!=1){
		sprintf(rida,"write error w_hr()<BR>");
		ExiT(rida);
		}
	q=fwrite(r->d,r->n*sizeof(int),1,of);
	if(q!=1){
		sprintf(rida,"write error w_hr()<BR>");
		ExiT(rida);
		}
	if(r->same!=(struct h *)NULL) w_hr(of,r->same);
	if(r->col!=(struct h *)NULL) w_hr(of,r->col);
}	

void w_HT(FILE *of){
	int i,q;
	q=fwrite(HT,sizeof(struct h *),HTL,of);
	if(q!=HTL){
		sprintf(rida,"write error w_HT()<BR>");
		ExiT(rida);
		}		
	for(i=0;i<HTL;i++){
		if(HT[i]!=(struct h *)NULL) w_hr(of,HT[i]);
		}
}					

 void w_PM(void){
	int i,j,q;
	sprintf(rida,"%s.pm",Nimi);
	of=opw();
	if(of==NULL){
		sprintf(rida,"create error w_PM()<BR>");
		ExiT(rida);
		}
	PM=DefArray(nr+1);
	for(i=1;i<=nr;i++){
		for(j=1;j<=nr;j++){
			PM[addr(i,j)]=Pm[i][j];
			}
		}	
	q=fwrite(PM,(nr+1)*(nr+1),1,of);
	if(q!=1){
		sprintf(rida,"write error w_PM()<BR>");  
		ExiT(rida);
		}
	fclose(of);
}  

void p_w(struct stat *b){
	int p;
	if(stat(rida,b)==-1){
		sprintf(rida,"w_tabs: stat failed<BR>");
		ExiT(rida);
		}
	p=b->st_size;
	fprintf(Logi,"<TR><TD>%s</TD><TD ALIGN=\"right\">%d</TD></TR>",rida,p);	
}	

/* TT: sorted by length terminal alphabet */
void make_TT(void){
	int i,j;
	for(i=0;i<tnr+1;i++) memcpy(TT[i],T[i],20);
	for(i=0;i<tnr;i++){
		for(j=i+1;j<tnr+1;j++){
			if(strlen(TT[i])<strlen(TT[j])){
				memcpy(word,TT[i],20);
				memcpy(TT[i],TT[j],20);
				memcpy(TT[j],word,20);
				}
			}
		}                       
}

int w_tabs(void){
	int q;
	struct stat *buf;
	fprintf(Logi,"<H3><FONT COLOR=\"#0000FF\">Result tables</H3><BR>");
	fprintf(Logi,"<TABLE BORDER=1><TR>");
	fprintf(Logi,"<TD><FONT COLOR=\"#0000FF\">File</TD><TD><FONT COLOR=\"#0000FF\">Size</TD></FONT>");
	buf=(struct stat *)malloc(sizeof(struct stat));
	if(buf==NULL){
		sprintf(rida,"w_tabs: I haven't %d bytes of memory..<BR>",
			sizeof(struct stat));
		ExiT(rida);
		}		
	PARM=(struct parm *)malloc(sizeof(struct parm));
	if(PARM==(struct parm *)NULL){
		sprintf(rida,"cannot create PARM<CR>");
		ExiT(rida);
		}
	memset(PARM,'\0',sizeof(struct parm));
	PARM->nr=nr;
	PARM->tnr=tnr;
	PARM->Pnr=Pnr;
	PARM->BRC=context;
	PARM->dep=dc;
	sprintf(rida,"%s.prm",Nimi);
	of=opw();
	if(of==NULL) goto bad;
	q=fwrite(PARM,sizeof(struct parm),1,of);
	if(q!=1){
		sprintf(rida,"write error PARM<BR>");  
		ExiT(rida);
		}
	fclose(of);
	p_w(buf);

	w_PM();
	p_w(buf);	

	sprintf(rida,"%s.t",Nimi);
	of=opw();
	if(of==NULL) goto bad;
	q=fwrite(&T,20,nr+1,of);	
	if(q!=nr+1){ 
		sprintf(rida,"write error w_T)<BR>");  
		ExiT(rida);
		}
	fclose(of);
	p_w(buf);

	make_TT();
	sprintf(rida,"%s.tt",Nimi);
	of=opw();
	if(of==NULL) goto bad;
	q=fwrite(&TT,20,tnr+1,of);	
	if(q!=tnr+1){ 
		sprintf(rida,"write error w_TT<BR>");  
		ExiT(rida);
		}
	fclose(of);
	p_w(buf);
	
	sprintf(rida,"%s.ht",Nimi);
	of=opw();
	if(of==NULL) goto bad;
	w_HT(of);
	fclose(of);
	p_w(buf);

	if(semantika!=(int *)NULL){
		sprintf(rida,"%s.sm",Nimi);
		of=opw();
		if(of==NULL) goto bad;
		q=fwrite(semantika,(tnr+Pnr+1)*sizeof(int),1,of);
		if(q!=1){
			sprintf(rida,"write error w_semantics<BR>");  
			ExiT(rida);
			}
		fclose(of);
		p_w(buf);
		}

	if(DT!=(struct D *)NULL){
		sprintf(rida,"%s.v",Nimi);
		of=opw();
		if(of==NULL) goto bad;
		w_V(of,DT);
		fclose(of);
		p_w(buf);
		}

	if(context==1){
		sprintf(rida,"%s.lc",Nimi);
		of=opw();
		if(of==NULL) goto bad;
		q=fwrite(LC,(nr+1)*(nr+1),1,of);
		if(q!=1){
			sprintf(rida,"write error w_LC<BR>");  
			ExiT(rida);
			}
		fclose(of);
		p_w(buf);

		sprintf(rida,"%s.rc",Nimi);
		of=opw();
		if(of==NULL) goto bad;
		q=fwrite(RC,(nr+1)*(nr+1),1,of);
		if(q!=1){
			sprintf(rida,"write error w_RC<BR>");  
			ExiT(rida);
			}		
		fclose(of);
		p_w(buf);
		}
	if(dc==1){
		sprintf(rida,"%s.dc",Nimi);
		of=opw();
		if(of==NULL) goto bad;
		w_DEP(of);
		fclose(of);
		p_w(buf);	
		}
	goto out;
bad:	sprintf(rida,"<BR>cannot write all the tables of %s.grm<BR>",Nimi);
	ExiT(rida);
out:    
	fprintf(Logi,"</TABLE>");
	fflush(Logi);
	return(1);
}
 
char *gM(int p){
	char *ptr=NULL;
	ptr=malloc(p);
	if(ptr==NULL){
		sprintf(rida,"gM: I haven't %d bytes of memory..",p);
		ExiT(rida);
		}
	return(ptr);
}

/* thestiku vljatrkk */
void pT(int v){
int j,i,p;
j=(v==0) ? 1 : tnr+1;
p=(v==0) ? tnr+1 : nr+1;
	for(i=j;i<p;i++){
		fprintf(Logi,"<FONT COLOR=\"008000\"> #%2d = </FONT>",i);
		if(v==0) fprintf(Logi,"%s<BR>",T[i]);
		else fprintf(Logi,"`%s'<BR>",T[i]);		
		}
	fprintf(Logi,"<BR>");
	fflush(Logi);
}

/* eraldab mlu uuele tipule thestiku V puusse */
struct D *newD(void){
	struct D *ptr;
	ptr=(struct D *)malloc(sizeof(struct D));
	if(ptr==NULL){
		sprintf(rida,"newD: I don't have memory enaugh..");
		ExiT(rida);
		}
	memset(ptr,'\0',sizeof(struct D));
	ptr->left=(struct D *)NULL;
	ptr->right=(struct D *)NULL;
	ptr->def=(struct R *)NULL;
	return(ptr);
}

/* eraldab mlu uuele NT-definitsioonile */
struct R *newR(void){
	struct R *ptr;
	ptr=(struct R *)malloc(sizeof(struct R));
	if(ptr==NULL){
		sprintf(rida,"newR: I don't have memory enaugh..");	
		ExiT(rida);
		}
	memset(ptr,'\0',sizeof(struct R));
	ptr->alt=(struct R *)NULL;
	return(ptr);
}


/* vabastab NT-definitsiooni mlu */
void free_R(struct R *r){
	if(r != (struct R *)NULL){
		 free_R(r->alt);
		 free(r->d);
		 free(r);
		 }
}

/* vabastab thestiku V puuga hivatud mlu */
void free_tree(struct D *t){
	if(t!=(struct D *)NULL){
		free_tree(t->left);
		free_tree(t->right);
		free_R(t->def);
		free(t);
		}
}

/* mitteterminali definitsiooni(de) trkk */
void printR(struct R *r){
int i,j;
char *s;
ring:	if(r != (struct R *)NULL){
		fprintf(Logi,"dl=%d<BR>",r->n);
		for(i=0;i<r->n;i++){
			j=r->d[i];
			s=T[j];		
			fprintf(Logi,"%s ",s);
			}
		fprintf(Logi,"<BR>");
		r=r->alt;
		goto ring;
		}
}

/* thestiku V elemendi otsimine/lisamine (x=1), otsimine (x=0) */
struct D *search(int x){
	struct D *t;
	int res;
	t=DT;
	if(t==(struct D *)NULL){
		if(x==0) goto exit;
		DT=DC;
		t=DC;
		goto out;
		}
ring: if(t->loc==0) res=strcmp(word,T[t->code]);
	 else res=strcmp(word,T[t->loc]);
	 if(res==0){
/*		free(DC);  */
		goto out;
		}
	 if(res<0){
		if(t->left != (struct D *)NULL){
			t=t->left;
			goto ring;
			}
		 else{
			if(x==0) goto exit;
			t->left=DC;
			t=DC;
			goto out;
			}
		}
		if(res>0){
			if(t->right != (struct D *)NULL){
				t=t->right;
				goto ring;
				}
			else{
				if(x==0) goto exit;
				t->right=DC;
				t=DC;
				goto out;
				}
			}
	goto out;
exit:	t=(struct D *)NULL;
/*	free(DC);			 */
out:	return(t);
}


/* thestiku V elemendi otsimine */
struct D *getV(char *key){
	struct D *t;
	int res;
	t=DT;
	if(t==(struct D *)NULL) goto exit;
ring:	if(t->loc==0) res=strcmp(key,T[t->code]);
		else res=strcmp(key,T[t->loc]);	
		if(res==0) goto out;
		if(res<0){
			if(t->left != (struct D *)NULL){
				t=t->left;
				goto ring;
				}
			else goto exit;
			}
		if(res>0){
			if(t->right != (struct D *)NULL){
				t=t->right;
				goto ring;
				}
			else goto exit;
			}
exit:	t=(struct D *)NULL;
out:	return(t);
}

/* thestiku V moodustamine: veateade */
void viga(int i){
int j;
	fprintf(Logi,"error in  grammar: nr of symbol=%d GrammarLength=%d<BR>",
		i,Glen);
	for(j=0;j<i;j++) fprintf(Logi,"%c",GBuf[j]);
	fprintf(Logi,"%c",sk);
	while(i<Glen){
		fprintf(Logi,"%c",GBuf[i]);
		i++;
		}
	fprintf(Logi,"<BR>");
}	

/* produktsioonide otseadresseeriv jrjestamine vljatrkiks */
void sort_rules(struct D *t,struct D *SD[],struct R *SR[]){
struct R *r;
	if(t!=(struct D *)NULL){
		if(t->tunnus==0){
			r=t->def;
			while(r!=(struct R *)NULL){
				if(r->P<0||r->P>Pnr){
					fprintf(Logi,"\ar->P=%d<BR>",r->P);
					fflush(Logi);
					}
				SD[r->P]=t;
				SR[r->P]=r;			
				r=r->alt;
				}	
			}
		sort_rules(t->left,SD,SR);
		sort_rules(t->right,SD,SR);
		}
}

/* mitteterminali ja tema definitsiooni(de) trkk - conf.c */
int print_rule(struct D *t,struct R *r){
int i,j;
char *s;
	fprintf(Logi,"<FONT COLOR=\"#0000FF\">P%2d: `%s' -> ",r->P,T[t->code]);
	for(i=0;i<r->n;i++){
		j=r->d[i];
		s=T[j];
		if(r->d[i]<=tnr) fprintf(Logi,"%s ",s);
		else fprintf(Logi,"`%s' ",s);
		}
	fprintf(Logi,"</FONT><BR>");
	return(1);
}

/* produktsiooni trkk */
void Print_rule(struct D *t,struct R *r){
int i,j;
	if(r != (struct R *)NULL){
		fprintf(Logi,"<FONT COLOR=\"#008000\">P%2d: </FONT>",r->P);
		fprintf(Logi,"`%s'",T[t->code]);
		fprintf(Logi,"<FONT COLOR=\"#FF0000\"> -> </FONT>");		
		for(i=0;i<r->n;i++){
			j=r->d[i];
			if(r->d[i]<=tnr)fprintf(Logi,"<FONT COLOR=\"#0000FF\">%s ",T[j]);
			else fprintf(Logi,"`%s' ",T[j]);
			fprintf(Logi,"</FONT>");
			}
		fprintf(Logi,"<BR>");
		}
}

/* produktsiooni trkk */
void Print_rule_comm(struct D *t,struct R *r){
int i,j;
	if(r != (struct R *)NULL){
		fprintf(Logi,"P%2d: `%s' -> ",r->P,T[t->code]);
		for(i=0;i<r->n;i++){
			j=r->d[i];
			if(r->d[i]<=tnr)fprintf(Logi,"%s ",T[j]);
			else fprintf(Logi,"`%s' ",T[j]);
			}
		fprintf(Logi,"<BR>");
		}
}

/* produktsiooni trkk faili*/
void Print_rule_f(struct D *t,struct R *r){
int i,j;
	if(r != (struct R *)NULL){
		fprintf(Sem,"  P%2d: `%s' -> ",r->P,T[t->code]);
		for(i=0;i<r->n;i++){
			j=r->d[i];
			if(r->d[i]<=tnr)fprintf(Sem,"%s ",T[j]);
			else fprintf(Sem,"`%s' ",T[j]);
			}
		fprintf(Sem,"\n");
		}
}

/* produktsioonide hulga P trkk */
int print_rules(struct D *t){
	int i;
/*	fprintf(Logi,"->print_rules<BR>");  */
	for(i=1;i<=Pnr;i++){
		SD[i]=(struct D *)NULL;
		SR[i]=(struct R *)NULL;
		}
	sort_rules(t,SD,SR);
/*	print_rules(t);  */
	for(i=1;i<=Pnr;i++){
		if(SR[i]!=NULL) Print_rule(SD[i],SR[i]);
		}
/*	fprintf(Logi,"<-print_rules<BR>");	*/
	return(1);
}		


/* produktsiooni 'vasaku poole' salvestamine */
struct D *leftside(int l){
	struct D *t;
	dl=0;
	DC=newD();
	DC->L=l;
	DL=DC;
	t=search(1);
	memset(def,'\0',20);
	if(t->code==0){
		nr++;
		if(nr>HTL){
			sprintf(rida,"too many symbols: nr=%d limes=%d<BR>",nr,HTL);
			ExiT(rida);
			}		
		t->code=nr;
		memcpy(T[nr],word,l+1);
		}
	return(t);
}

/* mitteterminal -> definitsioon */
void nonterm(int l){
	struct D *t;
	DC=newD();
	DC->L=l;
	t=search(1);
	if(t->code==0){
		nr++;
		if(nr>HTL){
			sprintf(rida,"too many symbols: nr=%d limes=%d<BR>",
				nr,HTL);
			ExiT(rida);
			}		
		t->code=nr;
		memcpy(T[nr],word,l+1);
		}
	def[dl]=t->code;
	dl++;
}

/* terminal thestikku V (flag=0) vi definitsiooni (flag=1) */
void term(int l,int flag){
	struct D *t;
	DC=newD();
	DC->tunnus=1;
	DC->L=l;
	t=search(1);
	if(t->code==0){
		tnr++;
		t->code=tnr;
		memcpy(T[tnr],word,20);
		}
	if(flag==1){	
		def[dl]=t->code;
		dl++;
		}
}

/* produktsiooni moodustamine ja salvestamine */
void makerul(void){
	struct R *r;
	int i;
	r=newR();
	r->P=Pnr;
	Pnr++;
	r->n=dl;
	r->d=(int *)malloc(dl*sizeof(int));
	if(r->d==NULL){ 
		sprintf(rida,"makerul: I don't have memory<BR>");
		ExiT(rida);
		}
	for(i=0;i<dl;i++) r->d[i]=def[i];
	for(i=0;i<20;i++) def[i]=0;
	r->alt=DL->def;
	DL->def=r;
	dl=0;	
}

/* terminaalse thestiku koostamine */
int Terms(void){
	int i,l,mid,left;  char k;
	int res=0;
	i=0;
	left=0;
	olek=0;
	mid=0;
nstate:	memset(word,'\0',20);
	l=0;
loop:	if(i>=Glen) goto out;
	if(GBuf[i]=='\t'){
		i++;
		goto loop;
		}
	switch(olek){
/* vasak */	case 0:{
			switch(GBuf[i]){
				case '-':{
					olek=1;
					mid=0;
					goto nstate;
					}
				case ' ':i++;
					 goto loop;
				case '`':{
					if(left==1){
						viga(i);
						res=1;
						}
					left=1;
					i++;
					goto loop;
					}
				case '\'':{
					mid=0;
					olek=1;   /* middle */
					i++;
					goto nstate;
					}
				default :{
					i++;
					goto loop;
					}
				}
			}   /* case0 */
/* middle */	case 1:	{
			switch(GBuf[i]){
				case ' ': i++;
					  goto loop;
				case '-': if(mid==0){
						mid=1;
						i++;
						}
					   else{
					   	viga(i);
						i++;
						res=1;
						}
					   goto loop;
				case '>':  if(mid==0){
						i++;
						viga(i);
						i++;
						res=1;
						goto loop;
						}
					   else{
					   	i++;
						olek=2;
						goto nstate;
						}
				}
			}   /* case1 */
/* right */	case 2: {
			switch(GBuf[i]){
				case ' ': i++;
					  goto loop;
				case '`': {
						  olek=3;
						  i++;
						  goto nstate;
						  }
				case '\n': left=0;
					   olek=0;
					   i++;
					   goto nstate;
				default: k=GBuf[i];  if(isgraph(k)){
						olek=4;
						goto nstate;
						}
					   else{
					   	viga(i);
						i++;
						res=1;
						}
					   i++;
					   goto loop;
				}
			}  /* case2 */
/* NT */	case 3: {
			k=GBuf[i]; if(isalnum(k)){
				i++;
				goto loop;
				}
			else{
				switch(GBuf[i]){
					case '`':
						viga(i);
						i++;
						res=1;
						goto loop;
					case '\'':
						i++;
						left=0;
						olek=2;
						goto nstate;
					case ' ': i++;
						  goto loop;
					default: viga(i);
						i++;
						res=1;
						goto loop;
					}
				}
			}   /* case3 */
/* T */		case 4:{
			if(GBuf[i]=='`'){
				term(l,0);
				olek=2;
				goto nstate;
				}
			k=GBuf[i]; if(isgraph(k)){
				word[l]=GBuf[i];
				i++;
				l++;
				goto loop;
				}
			if(GBuf[i]==' '){
				i++;
				term(l,0);
				olek=2;
				goto nstate;
				}
			if(GBuf[i]=='\n'){
				i++;
				term(l,0);
				olek=0;
				left=0;
				goto nstate;
				}
			}    /* case4 */
		}   /* switch olek */
out:	return(res);
}

/* mitteterminaalse thestiku ja produktsioonide hulga koostamine */
int Rules(void){
	int i,l,mid,left,res=0;
	char k;
	i=0;
	left=0;
	mid=0;

nstate:	memset(word,'\0',20);
	l=0;
loop:	if(i>=Glen) return(0);
	if(GBuf[i]=='\t'){
		i++;
		goto loop;
		}
	switch(olek){
/* vasak */	case 0:{
			switch(GBuf[i]){
				case '-':{
					olek=1;
					mid=0;
					goto nstate;
					}
				case ' ':i++;
					 goto loop;
				case '`':{
					if(left==1){
						viga(i);
						i++;
						res=1;
						}
					left=1;
					i++;
					goto loop;
					}
				case '\'':{
					mid=0;
					DL=leftside(l);
					olek=1;   /* middle */
					left=0;
					i++;
					goto nstate;
					}
				default :{
					k=GBuf[i]; if(isalnum(k)){
						word[l]=GBuf[i];
						l++;
						i++;
						}
					else{
						viga(i);
						i++;
						res=1;
						}
					goto loop;
					}
				}
			}   /* case0 */
/* middle */	case 1:	{
			switch(GBuf[i]){
				case ' ': i++;
					  goto loop;
				case '-': if(mid==0){
						mid=1;
						i++;
						}
					   else{
					   	viga(i);
						i++;
						res=1;
						}
					   goto loop;
				case '>':  if(mid==0){
						i++;
						viga(i);
						res=1;
						goto loop;
						}
					   else{
					   	i++;
						if(GBuf[i]=='\t') i++;
						olek=2;
						goto nstate;
						}
				}
			}   /* case1 */
/* right */	case 2: {
			switch(GBuf[i]){
				case ' ': i++;
					  goto loop;
				case '`': {
						  olek=3;
						  i++;
						  goto nstate;
						  }
				case '\n': makerul();
					   left=0;
					   olek=0;
					   i++;
					   goto nstate;
				default: k=GBuf[i];  if(isgraph(k)){
						olek=4;
						goto nstate;
						}
					   else{
					   	viga(i);
						i++;
						res=1;
						}
					   i++;
					   goto loop;
				}
			}  /* case2 */
/* NT */	case 3: {
			k=GBuf[i]; if(isalnum(k)){
				word[l]=GBuf[i];
				i++;
				l++;
				goto loop;
				}
			else{
				switch(GBuf[i]){
					case '`':
						viga(i);
						i++;
						res=1;
						goto loop;
					case '\'':
						nonterm(l);
						i++;
						left=0;
						olek=2;
						goto nstate;
					case ' ': i++;
						  goto loop;
					default: viga(i);
						i++;
						res=1;
						goto loop;
					}
				}
			}   /* case3 */
/* T */		case 4:{
			if(GBuf[i]=='`'){
				term(l,1);
				olek=2;
				goto nstate;
				}
			k=GBuf[i]; if(isgraph(k)){
				word[l]=GBuf[i];
				i++;
				l++;
				goto loop;
				}
			if(GBuf[i]==' '){
				i++;
				term(l,1);
				olek=2;
				goto nstate;
				}
			if(GBuf[i]=='\n'){
				i++;
				term(l,1);
				makerul();
				olek=0;
				left=0;
				goto nstate;
				}
			}    /* case4 */
		}   /* switch olek */
	return(res);
}

void print_def(struct R *r){
int i,j;
	for(i=0;i<r->n;i++){
		j=r->d[i];
		if(j<=tnr) fprintf(Logi,"%s ",T[j]);
		else fprintf(Logi,"`%s' ",T[j]);
		}
	fprintf(Logi,"<BR>");
}

int make_sem(char *B){
	int i=0;
	int p,ix,kood,piir;
	piir=tnr+Pnr+1;
	i=0;
	p=0;
	if(B[i]=='$'){
		i++;
		end: while(B[i]!='\n') i++;
		i++;
		return(i);
		}
	if((B[i]=='P')||(B[i]=='p')){
		i++;
		p=tnr;
		}
	i+=sscanf(B+i,"%d",&ix);
	p=p+ix;
	while(B[i]!='=') i++;
	i++;
	i+=sscanf(B+i,"%d",&kood);
	if(p>=piir){
		fprintf(Logi,"p=%d piir=%d<BR>",p,piir);
		goto end;
		}
/*	fprintf(Logi,"p=%d kood=%d<BR>",p,kood);  fflush(Logi);  */
	semantika[p]=kood;
	goto end;
}
	
/* semantikamassiivi titmine */
int put_semant(void){
	char *B;
	int i,piir;
	char finame[256];
	piir=tnr+Pnr+1;
	semantika=(int *)malloc((piir)*sizeof(int));
	if(semantika==NULL){
		sprintf(rida,"No memory for semantics: l=%d",piir);
		ExiT(rida);
		}
	for(i=0;i<piir;i++) semantika[i]=0;	
	memset(finame,'\0',256);
	for(i=0;i<256;i++){
		if((fname[i]!='.')&&(fname[i]!='\0')) finame[i]=fname[i];
		}
	strcat(finame,".sem");
	fprintf(Logi,"Semantics file is %s<BR>",finame); fflush(Logi);
	Sem=fopen(finame, "r");
	if(Sem!=NULL) goto readit;

	fprintf(Logi,"semantics file %s is lack<BR>",finame);
	fprintf(Logi,"I'll make it myself<BR>");
	fflush(Logi);
	Sem=fopen(finame,"w");
	if(Sem==NULL){
		sprintf(rida,"cannot create file %s",finame);
		ExiT(rida);
		}
	for(i=1;i<piir-1;i++){
		semantika[i]=i;
		if(i<=tnr) fprintf(Sem,"%d=%d <SPACE>$ %s\n",i,i,T[i]);
		else{
			fprintf(Sem,"P%d=%d <SPACE>$ ",i-tnr,i);
			Print_rule_f(SD[i-tnr],SR[i-tnr]);
			}
		}					
	fclose(Sem);
	goto showit;

readit:
	fclose(Sem);
	B=r_text(finame);
	i=0;
	while(i<P_length){
		i+=make_sem(B+i);
		}
	fflush(Logi);

showit:
	sort_rules(DT,SD,SR);
	for(i=1;i<piir;i++){
		if(semantika[i]>0){
			if(i<=tnr) fprintf(Logi,"%s=%d<BR>",T[i],semantika[i]);
			else{
				fprintf(Logi,"P%d=%d<SPACE> <SPACE> ",i-tnr,semantika[i]);
				fprintf(Logi,"<FONT COLOR=\"#008000\"> $");  
				Print_rule_comm(SD[i-tnr],SR[i-tnr]);
				fprintf(Logi,"</FONT>");
				}
			fflush(Logi);	
			}  
		}
	return(1);
}

void make_prod(void){
	int i,j;
	struct h *C,*D;
	j=0;
	for(i=0;i<HTL;i++){
		if(HT[i]!=(struct h *)NULL){
			C=HT[i];
			coll: D=C;
			prod[j]=C;
			j++;
			same: if(D->same!=(struct h *)NULL){
				D=D->same;
				prod[j]=D;
				j++;
				goto same;
				}
			if(C->col!=(struct h *)NULL){
				C=C->col;	
				goto coll;
				}	
			}
		}			
}

int constr(void){
	int pre,i;
	char *Ti;
/* konstruktori initsialiseerinine */
	int ret=1;
	olek=0;
	Pnr=1;
	Index=1;      /* eelnevusteisenduste uute produktsioonide suffiks */
	DT=(struct D *)NULL;     /* first   */
	DC=(struct D *)NULL;     /* current */
	DL=(struct D *)NULL;     /* last    */
	DN=(struct D *)NULL;     /* new     */
	context=0;               /* independent & */
	dc=0;                    /* dependent context */
	tnr=0;  /* terminaalse thestiku jooksev pikkus */
	nr=0;   /* thestiku V jooksev pikkus */
	NR=0;   /* nr eelnevusteisenduste ajal */
	BRC=0;  /* hesuguste paremate pooltega produktsioonide arv */
	rules=NULL;
	for(i=0;i<(2*HTL);i++){
		Ti=T[i];
		memset(Ti,'\0',20);
		}
/* terminaalse thestiku moodustamine */
	if(Terms()==1){
		ret=0;
		goto bye;
		}
	nr=tnr;
	fprintf(Logi,"<H4><FONT COLOR=\"#0000FF\">Terminal alphabet</H4></FONT>");
	pT(0);
	fprintf(Logi,"<HR>");
/* mitteterminaalse thestiku ja produktsioonide hulga moodustamine */
	if(Rules()==1){
		ret=0;
		goto bye;
		}
	fprintf(Logi,"<H4><FONT COLOR=\"#0000FF\">Nonterminal alphabet</H4></FONT>");
	pT(1);
	fprintf(Logi,"<HR>");
	fprintf(Logi,"<H4><FONT COLOR=\"#0000FF\">Productions</H4></FONT>");
	print_rules(DT);
	fprintf(Logi,"<HR>");	
/* left- ja rightmost-hulkade moodustamine, eelnevusmaatriksi koostamine */
new: 
	memset(Pm,'\0',HTL*HTL);
	memset(Lm,'\0',HTL*HTL);
	memset(Rm,'\0',HTL*HTL);
	make_LRB();
	fprintf(Logi,"<H4><FONT COLOR=\"#0000FF\">Leftmost-set</H4></FONT>");
	print_LRM(Lm);  
	fprintf(Logi,"<HR>");	
	fprintf(Logi,"<H4><FONT COLOR=\"#0000FF\">Rightmost-set</H4></FONT>");
	print_LRM(Rm); 
	fprintf(Logi,"<HR>");	
	p_all_lr();
	fprintf(Logi,"<HR>");		
	pre=make_PM();
	fprintf(Logi,"<H4><FONT COLOR=\"#0000FF\">Precedence matrix</H4></FONT>");
	print_PM(); 
	fprintf(Logi,"<HR>");	
	print_rela();  
	fprintf(Logi,"<HR>");	
	fflush(Logi);	
/*	if(Nimi[0]=='G') print_PM(); 
	else print_rela(); */
	if(pre==1) goto on;
/* eelnevustest ja eelnevusteisendused */
	fprintf(Logi,"<H4><FONT COLOR=\"#0000FF\">Precedence varies</H4></FONT>");
	if(conflicts()>0){
		fprintf(Logi,"<H4><FONT COLOR=\"#0000FF\">New grammar</H4></FONT>");
		print_rules(DT);
		fprintf(Logi,"<HR>");		
		goto new;
		}
on:	
	fprintf(Logi,"<H4><FONT COLOR=\"#008000\">");
	fprintf(Logi,"<H3>Grammar %s is a precedence grammar</H3></FONT>",fname);
/* produktsioonide 'paremate poolte' paisktabeli koostamine, pratavustest */
	HashRules(DT);
	DepV=DefVect(Pnr);
	if(BRC==0){
		context=0;
		fprintf(Logi,"<H4><FONT COLOR=\"#008000\">");
		fprintf(Logi,"<H4>Grammar %s is invertible</H4></FONT>",fname);
		goto semm;
		}
	fprintf(Logi,"<H4><FONT COLOR=\"#FF0000\">");
	fprintf(Logi,"<H4>Grammar %s is not invertible</H4></FONT>",fname);
	context=1;
/* sltumatu konteksti hulkade moodustamine, BRC(1|1)-test */
	fprintf(Logi,"<HR>");
	if(LC!=(char *)NULL) free(LC);
	LC=DefArray(nr+1);
	if(RC!=(char *)NULL) free(RC);
	RC=DefArray(nr+1);	
	make_all_indep();
	p_all_brc();
	fflush(Logi);
	for(i=0;i<Pnr;i++) prod[i]=(struct h *)NULL;
	make_prod();
	dc=0;
	if(make_BRC()==0) goto sos;
	if(BRC==0&&dep==0){
		fprintf(Logi,"<H4><FONT COLOR=\"#008000\">");	
		fprintf(Logi,"<H4>Grammar %s is BRC(1|1)-reducible</H4></FONT>",fname);
		goto semm;
		}
	fflush(Logi);
	if(dc==1){
		fprintf(Logi,"<H4><FONT COLOR=\"#008000\">");	
		fprintf(Logi,"<H4>Grammar %s is BRC(1,1)-reducible</H4></FONT>",fname);
		fflush(Logi);
		del_dep();   
		print_all_cxt();
		goto semm;
		}
sos:
	fprintf(Logi,"<H4><FONT COLOR=\"#FF0000\">");
	fprintf(Logi,"Grammar %s is not BRC-reducible</H4></FONT>",fname);
	p_nlist();
/*	print_all_cxt();  */
	ret=0;
	goto bye;
/* semantika omistamine */
semm:
	fprintf(Logi,"<HR>");
	fprintf(Logi,"<H4><FONT COLOR=\"#0000FF\">");
	fprintf(Logi,"<H4>Semantics</H4></FONT>");
	fflush(Logi);
	if(semantika!=(int *)NULL){
		free(semantika);
		semantika=(int *)NULL;
		}
	put_semant(); 
	Sn=nr;
	fprintf(Logi,"<HR>");	
	ret=w_tabs();
	fprintf(Logi,"<HR>");	
	if(rdf!=NULL) make_rtf();	
	fprintf(Logi,"Look at result <A HREF=\"%s\">tables</A>",RD);
bye:
	return(ret);
}

void make_rtf(void){
int i;
	fprintf(rdf,"<HTML><HEAD><TITLE>");
	fprintf(rdf,"TABLES %s",fname);
	fprintf(rdf,
	"</TITLE></HEAD><BODY><H1><FONT COLOR=\"#0000FF\">CONSTRUCTOR TABLES of the Grammar %s</H1>",
		fname);
	fprintf(rdf,"<BODY LINK=\"blue\"><BODY VLINK=\"blue\"><BODY ALINK=\"red\"></FONT><B>");	
	fflush(rdf);	
	fprintf(rdf,"<UL><LI><A HREF=\"#parm\">Parameters</A></LI>");
	fprintf(rdf,"<LI><A HREF=\"#t\">Alphabet V</A></LI>");
	fprintf(rdf,"<LI><A HREF=\"#tt\">Scanner Table</A></LI>");	
	fprintf(rdf,"<LI><A HREF=\"#v\">Tree of the Alphabet V</A></LI>");
	fprintf(rdf,"<LI><A HREF=\"#ht\">Reduce Table</A></LI>");
	fprintf(rdf,"<LI><A HREF=\"#pm\">Precedence Matrix</A></LI>");
	if(PARM->BRC>0){
		fprintf(rdf,"<LI><A HREF=\"#lc\">Left Context</A></LI>");
		fprintf(rdf,"<LI><A HREF=\"#rc\">Right Context</A></LI>");
		}
	if(PARM->dep>0)
		fprintf(rdf,"<LI><A HREF=\"#dc\">Dependent Context</A></LI>");	
	fprintf(rdf,"<LI><A HREF=\"#sm\">Semantics</A></LI>");	
	fprintf(rdf,"</UL>");	
	fprintf(rdf,"<HR>");
	fprintf(rdf,"<P><A NAME=\"parm\"></A>");
	fprintf(rdf,"<H2>Parameters</H2>");
	fprintf(rdf,"File %s.prm<BR>",Nimi);
	fprintf(rdf,"<PRE>");
	fprintf(rdf,"struct parm{\n");
	fprintf(rdf,"\tint nr   //t&auml;hestiku V pikkus\n");
	fprintf(rdf,"\tint tnr  //t&auml;hestiku V<SUB>T</SUB> pikkus\n");
	fprintf(rdf,"\tint BRC  //0: G on p&ouml;&ouml;ratav\n");
	fprintf(rdf,"\tint Pnr  //Produktsioonide arv\n");
	fprintf(rdf,"\tint dep  //1: s&otilde;ltuv kontekst\n");
	fprintf(rdf,"\tint itl  //identifikaatorite arv (Parser)\n");
	fprintf(rdf,"\tint ktl  //konstantide arv (Parser)\n");
	fprintf(rdf,"}\n\n");
	fprintf(rdf,"nr=%d tnr=%d BRC=%d Pnr=%d dep=%d itl=%d ktl=%d\n\n",
	PARM->nr,PARM->tnr,PARM->BRC,PARM->Pnr,PARM->dep,PARM->itl,PARM->ktl);
	fprintf(rdf,"</P></PRE><A NAME=\"t\"></A><HR>");
	fprintf(rdf,"<H2>Alphabet V</H2>");
	fprintf(rdf,"File %s.t<BR>",Nimi);
	fprintf(rdf,"<PRE>");
	for(i=1;i<=nr;i++) fprintf(rdf,"%s ",T[i]);
	fprintf(rdf,"</PRE><BR><BR><HR>");
	fprintf(rdf,"</P></PRE><A NAME=\"tt\"></A><HR>");
	fprintf(rdf,"<H2>Scanner Table</H2>");
	fprintf(rdf,"File %s.tt<BR>",Nimi);
	fprintf(rdf,"<PRE>");
	for(i=0;i<=tnr;i++) fprintf(rdf,"%s ",TT[i]);
	fprintf(rdf,"</PRE><BR><BR><HR>");	
	fprintf(rdf,"<A NAME=\"v\"></A>");
	fprintf(rdf,"<H2>Tree of the Alphabet V</H2>");
	fprintf(rdf,"File %s.v<BR>",Nimi);
/* Produktsiooni parem pool */
	fprintf(rdf,"<PRE>");
	fprintf(rdf,"struct R{<BR>");
	fprintf(rdf,"\tint P;         /* produktsiooni jrk-nr */<BR>");
	fprintf(rdf,"\tint sem;       /* semantikakood */<BR>");
	fprintf(rdf,"\tint n;         /* NT definitsiooni pikkus */<BR>");
	fprintf(rdf,"\tint *d;        /* NT definitsioon */<BR>");
	fprintf(rdf,"\tstruct R *alt; /* NT alternatiivne definitsioon */<BR>");
	fprintf(rdf,"}<BR><BR>");

/* Thestiku V symboli (NT vi T) kirje */
	fprintf(rdf,"struct D{<BR>");
	fprintf(rdf,"\tint tunnus;  /* 0: NT, 1: T */<BR>");
	fprintf(rdf,"\tint code;    /* vahekeelne kood */\n");
	fprintf(rdf,"\tint L;       /* NT v&otilde;i id/const nime pikkus  */\n");
	fprintf(rdf,"\tint loc;     /* ident | const : nr */\n");
	fprintf(rdf,"\tint icx;     /* itl v&otilde;i ktl - IT v&otilde;i KT index */\n");
	fprintf(rdf,"\tstruct D *left;   /* kahendpuu viidad (v&otilde;ti on T[code]) */\n");
	fprintf(rdf,"\tstruct D *right;\n");
	fprintf(rdf,"\tstruct R *def;\n");
	fprintf(rdf,"}\n\n");
	print_tree(DT);
	fprintf(rdf,"</PRE><HR>");
	fprintf(rdf,"<A NAME=\"ht\"></A>");
	fprintf(rdf,"<H2>Reduce Table</H2>");
	fprintf(rdf,"File %s.ht<BR>",Nimi);
	fprintf(rdf,"<PRE>");
	fprintf(rdf,"struct h{\n");
	fprintf(rdf,"\tint P;          /* produktsiooni jrk-nr */\n");
	fprintf(rdf,"\tint n;          /* definitsiooni pikkus  */\n");
	fprintf(rdf,"\tint NT;         /* defineeritav nonterminal  */\n");
	fprintf(rdf,"\tint *d;         /* definitsioon */\n");
	fprintf(rdf,"\tint nc;         /* 1 - s&otilde;ltuv kontekst */\n");
	fprintf(rdf,"\tchar *c;        /* reservis */\n");
	fprintf(rdf,"\tstruct h *same; /* sama parem pool */\n");
	fprintf(rdf,"\tstruct h *col;  /* p&otilde;rkeviit */\n");
	fprintf(rdf,"}\n\n");
	print_h_tabel();
	fprintf(rdf,"</PRE><HR>");
	fprintf(rdf,"<A NAME=\"pm\"></A>");
	fprintf(rdf,"<H2>Precedence Matrix</H2>");
	fprintf(rdf,"File %s.pm<BR>",Nimi);
	print_rPM();
	fprintf(rdf,"<BR><BR><HR>");
if(PARM->BRC>0){
	fprintf(rdf,"<A NAME=\"lc\"></A>");
	fprintf(rdf,"<H2>Left Context</H2>");
	fprintf(rdf,"File %s.lc<BR>",Nimi);
	print_rLC();
	fprintf(rdf,"<BR><BR><HR>");
	fprintf(rdf,"<A NAME=\"rc\"></A>");
	fprintf(rdf,"<H2>Right Context</H2>");
	fprintf(rdf,"File %s.rc<BR>",Nimi);
	print_rRC();	
	fprintf(rdf,"<BR><BR><HR>");
	}
if(PARM->dep>0){	
	fprintf(rdf,"<A NAME=\"dc\"></A>");
	fprintf(rdf,"<H2>Dependent Context</H2>");
	fprintf(rdf,"File %s.dc<BR>",Nimi);
	print_DEP();
	fprintf(rdf,"<BR><BR><HR>");	
	}
	fprintf(rdf,"<A NAME=\"sm\"></A>");
	fprintf(rdf,"<H2>Semantics</H2>");
	fprintf(rdf,"File %s.sm<BR><BR>",Nimi);
	for(i=1;i<=tnr+Pnr;i++) fprintf(rdf,"%d ",semantika[i]);
	fprintf(rdf,"</BODY></HTML>");
	fflush(rdf);
	fclose(rdf);
}

int construc(void){
	int ret=0;
	time_t t0,t1;
	GBuf=NULL;
	Logi=fopen(L_name,"w");
	if(Logi==NULL){
		printf("Cannot open log-book<BR>");
		return(0);
		}
	fprintf(Logi,"<HTML><HEAD><TITLE>");
	time(&t0);
	fprintf(Logi,"CONSTRUCTOR %s",fname);
	fprintf(Logi,
	"</TITLE></HEAD><BODY><H2>Start of CONSTRUCTOR for the Grammar %s %s</H2>",
		fname,asctime(localtime(&t0)));
	fprintf(Logi,"</FONT><B>");	
	if(gramm()==0) goto jokk;
	ret=constr();

jokk:
	time(&t1);
	fprintf(Logi,"<FONT COLOR=\"#0000FF\">");	
	fprintf(Logi,"<H4>Finish of CONSTRUCTOR %s</H4>",asctime(localtime(&t1)));	
	fprintf(Logi,"</FONT></BODY></HTML>");
	fflush(Logi);
	fclose(Logi);
	return(ret);
}

int main(int argc,char **argv){
	if(argc!=2){
		printf("I do need only the name of a grammar<BR>"); abort();
		}
	fname=(char *)malloc(256);
	Nimi=(char *)malloc(9);
	L_name=(char *)malloc(256);
	memset(RD,'\0',256);
	memset(fname,'\0',256);
	memset(Nimi,'\0',9);
	memset(L_name,'\0',256);	
	sprintf(fname,"%s",argv[1]);
	sprintf(L_name,"%s",argv[1]);	
	sprintf(RD,"%srd.htm",argv[1]);
	rdf=fopen(RD,"w");
	strcpy(Nimi,fname);
	strcat(fname,".grm");
	strcat(L_name,".htm");	
	printf("fname=%s Nimi=%s L_name=%s\n",fname,Nimi,L_name);
	construc();
	return(1);
}		