; The Waite Group's MS-DOS Developer's Guide, Second Edition,
; John Angermeyer jt,Howard W. Sams & Company, 1989, pp 724-725
;
; bin2dec
; INPUT: AX - number to be displayed
;	 CH - minimum number of digits to be displayed
;	 DX = 0, if number is unsigned, 1, if signed
; OUTPUT None
;
;
	.MODEL	small
	.STACK	100h
	.DATA
	.CODE
	PUBLIC bin2dec
	PUBLIC readint	
;
bin2dec	PROC	NEAR
	push	ax
	push	bx
	push	cx
	push	dx
	mov	cl,0
	mov 	bx,10
	cmp	dx,0
	je	more_dec
	or	ax,ax
	jnl	more_dec
	neg	ax
;	@DisChr	'-'
	push	ax
	push	dx
	mov	dl,'-'
	mov 	ah,02h
	int	21h
	pop	dx
	pop	ax
more_dec:
	xor	dx,dx
	div	bx
	push	dx
	inc	cl
	or	ax,ax
	jnz	more_dec
; Main Digit Print Loop - Reverse Order
	sub	ch,cl
	jle	morechr
	xor	dx,dx
morezero:
	push	dx
	inc	cl
	dec	ch
	jnz	morezero
morechr:
	pop	dx
	add	dl,30h
; DisChr
	push	ax
	push	dx
	mov 	ah,02h
	int	21h
	pop	dx
	pop	ax
	dec	cl
	jnz	morechr
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
bin2dec	ENDP
;
; vt. ka
; Turbo Assembler. Users Guide, Version 1.0, Borland International, 1989
; p 55; Angermayer et al, p.560
;
; readint
; INPUT: none
; OUTPUT AX - sisestatud ja teisendatud arv
;
;
readint	PROC	NEAR
	push	bx
	push	cx	;save
	push	dx	;registers; res=ax
	xor	ax,ax   ;arv
ring:	push	ax	;save
	mov	ah,1	;DOS keyboard input
	int	21h	;get the next symbol
	mov	cl,al	;new digit in cl
	sub	cl,30h	;symbol->10nd-nr
	cmp	al,13	;Enter?
	jz	oki	;valmis
	pop	ax	;senine arv
	mov	dx,10
	mul	dx	;senine arv * 10
	xor	ch,ch	;prepare for 16-bit add
	add	ax,cx	;new digit is added in
	jmp	ring			
oki:	mov	dl,10	;linefeed
	mov	ah,2	;DOS display output
	int	21h
	pop	ax
	pop	dx
	pop	cx
	pop	bx
	ret	
readint ENDP
	END
	